Connect the Graph

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)

Total Submission(s): 456    Accepted Submission(s): 144

Special Judge

Problem Description
Once there was a special graph. This graph had
n
vertices and some edges. Each edge was either white or black. There was no edge connecting one vertex and the vertex itself. There was no two edges connecting the same pair of vertices. It is special because the each vertex is connected to at most two black
edges and at most two white edges.



One day, the demon broke this graph by copying all the vertices and in one copy of the graph, the demon only keeps all the black edges, and in the other copy of the graph, the demon keeps all the white edges. Now people only knows there are
w0
vertices which are connected with no white edges,
w1
vertices which are connected with 1
white edges, w2
vertices which are connected with 2
white edges, b0
vertices which are connected with no black edges,
b1
vertices which are connected with 1
black edges and b2
vertices which are connected with 2
black edges.



The precious graph should be fixed to guide people, so some people started to fix it. If multiple initial states satisfy the restriction described above, print any of them.
 
Input
The first line of the input is a single integer
T (T≤700),
indicating the number of testcases.



Each of the following T
lines contains w0,w1,w2,b0,b1,b2.
It is guaranteed that 1≤w0,w1,w2,b0,b1,b2≤2000
and b0+b1+b2=w0+w1+w2.




It is also guaranteed that the sum of all the numbers in the input file is less than
300000.
 
Output
For each testcase, if there is no available solution, print
−1.
Otherwise, print m
in the first line, indicating the total number of edges. Each of the next
m
lines contains three integers x,y,t,
which means there is an edge colored t
connecting vertices x
and y.
t=0
means this edge white, and t=1
means this edge is black. Please be aware that this graph has no self-loop and no multiple edges. Please make sure that
1≤x,y≤b0+b1+b2.
 
Sample Input
2
1 1 1 1 1 1
1 2 2 1 2 2
 
Sample Output
-1
6
1 5 0
4 5 0
2 4 0
1 4 1
1 3 1
2 3 1
 
Author
XJZX
 
Source
 
Recommend
wange2014   |   We have carefully selected several similar problems for you:  

pid=5395" target="_blank">5395 5394 

pid=5393" target="_blank">5393 

pid=5392" target="_blank">5392 

pid=5391" target="_blank">5391 

 

构造法:

首先保证度数之和为偶数,即w1=b1=1 ,否则无解

又w0,w1,w2,b0,b1,b2均为正数 故

当n=4时,仅仅有1种情况 1 2 1 不是无解

当n≥4时,先构造2个环分别为白环,黑环

对于奇数n:



  白环 1 2 3 ... n



  黑环 1 3 5 ... n 2 4 6 ... n-1



对于偶数n:



  白环 1 2 3 ... n



  黑环 1 3 5 ... n-1 2 n n-2 n-4 ... 4

此时,对于每一个环而言,构造答案

1-2-2-...-2-2-1
1-1 1-1 .. 1-1
1-1 0 .. 0

#include<cstdio>
#include<cstring>
#include<cstdlib>
#include<algorithm>
#include<functional>
#include<iostream>
#include<cmath>
#include<cctype>
#include<ctime>
using namespace std;
#define For(i,n) for(int i=1;i<=n;i++)
#define Fork(i,k,n) for(int i=k;i<=n;i++)
#define Rep(i,n) for(int i=0;i<n;i++)
#define ForD(i,n) for(int i=n;i;i--)
#define RepD(i,n) for(int i=n;i>=0;i--)
#define Forp(x) for(int p=pre[x];p;p=next[p])
#define Forpiter(x) for(int &p=iter[x];p;p=next[p])
#define Lson (x<<1)
#define Rson ((x<<1)+1)
#define MEM(a) memset(a,0,sizeof(a));
#define MEMI(a) memset(a,127,sizeof(a));
#define MEMi(a) memset(a,128,sizeof(a));
#define INF (2139062143)
#define F (100000007)
#define MAXD (2000+10)
#define MAXN (6000+10)
typedef long long ll;
ll mul(ll a,ll b){return (a*b)%F;}
ll add(ll a,ll b){return (a+b)%F;}
ll sub(ll a,ll b){return (a-b+llabs(a-b)/F*F+F)%F;}
void upd(ll &a,ll b){a=(a%F+b%F)%F;}
int a2[MAXN],a1[MAXN],n;
void calc(int *a,int n0,int n1,int n2,int p)
{
int i=1;
if (n1==0&&n2==0) return;
For(i,n2+1)
{
printf("%d %d %d\n",a[i],a[i+1],p);
}
n1-=2;
for(int i=n2+3,j=1;j<=n1;i+=2,j+=2) printf("%d %d %d\n",a[i],a[i+1],p); }
int main()
{
// freopen("C.in","r",stdin);
// freopen(".out","w",stdout); int T; cin>>T;
while(T--) {
int w0,w1,w2,b0,b1,b2;
scanf("%d%d%d%d%d%d",&w0,&w1,&w2,&b0,&b1,&b2);
n=w0+w1+w2; //特判
if ((w1&1)||(b1&1)) { printf("-1\n");continue;} int m=(w1+2*w2+b1+2*b2)/2; if (n==4)
{
puts("4\n1 2 0\n1 3 0\n2 3 1\n3 4 1");
continue;
}
else if (n>4) {
For(i,n) a1[i]=i;
if (n%2==0)
{
for(int i=1,j=1;i<=n/2;i++,j+=2) a2[i]=j;
for(int i=n/2+1,j=2;i<=n;i++,j+=2) a2[i]=j;
a2[n+1]=1;
}
else {
for(int i=1,j=1;i<=n/2+1;i++,j+=2) a2[i]=j;
a2[n/2+2]=2;
for(int i=n/2+3,j=n-1;i<=n;i++,j-=2) a2[i]=j;
a2[n+1]=1;
}
cout<<m<<endl;
calc(a1,w0,w1,w2,0);
calc(a2,b0,b1,b2,1);
} } return 0;
}

HDU 5302(Connect the Graph- 构造)的更多相关文章

  1. [2015hdu多校联赛补题]hdu5302 Connect the Graph

    题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5302 题意:给你一个无向图,它的边要么是黑色要么是白色,且图上的每个点最多与两个黑边两个白边相连.现在 ...

  2. HDU 6343.Problem L. Graph Theory Homework-数学 (2018 Multi-University Training Contest 4 1012)

    6343.Problem L. Graph Theory Homework 官方题解: 一篇写的很好的博客: HDU 6343 - Problem L. Graph Theory Homework - ...

  3. HDU 4725 The Shortest Path in Nya Graph [构造 + 最短路]

    HDU - 4725 The Shortest Path in Nya Graph http://acm.hdu.edu.cn/showproblem.php?pid=4725 This is a v ...

  4. HDU 5876:Sparse Graph(BFS)

    http://acm.hdu.edu.cn/showproblem.php?pid=5876 Sparse Graph Problem Description   In graph theory, t ...

  5. hdu 3371 Connect the Cities

    题目连接 http://acm.hdu.edu.cn/showproblem.php?pid=3371 Connect the Cities Description In 2100, since th ...

  6. HDU - 6313 Hack It(构造)

    http://acm.hdu.edu.cn/showproblem.php?pid=6313 题意 让你构造一个矩阵使得里面不存在四个顶点都为1的矩形,并且矩阵里面1的个数要>=85000 分析 ...

  7. HDU 3371 Connect the Cities(prim算法)

    题目链接: http://acm.hdu.edu.cn/showproblem.php?pid=3371 Problem Description In 2100, since the sea leve ...

  8. hdu 3371 Connect the Cities(最小生成树)

    题目:http://acm.hdu.edu.cn/showproblem.php?pid=3371 984ms风险飘过~~~ /************************************ ...

  9. HDU 6343 - Problem L. Graph Theory Homework - [(伪装成图论题的)简单数学题]

    题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=6343 Time Limit: 2000/1000 MS (Java/Others) Memory Li ...

随机推荐

  1. timeslot概念(还是不太懂呀!!)

    rules: 1. event.triggered只会保持一个time_slot,在下一个time_slot将会丢失这个标记,如果不能保证在每一个time_slot都会检测到这个标志,那么将会丢失这个 ...

  2. python基础知识02-序列类型的方法

    列表的方法: 增:append() insert() extend()只能添加序列类型. .改li[0]= '123' li.insert(2,'123') 2个参数,位置,值 li.remove(' ...

  3. 剑指Offer(书):二叉树的下一个节点

    题目:给定一个二叉树和其中的一个结点,请找出中序遍历顺序的下一个结点并且返回.注意,树中的结点不仅包含左右子结点,同时包含指向父结点的指针. 分析:若一个节点有右子树,那么他的下一个节点就是他右子树中 ...

  4. .NET中的缓存实现

    软件开发中最常用的模式之一是缓存,这是一个简单但非常有效的概念,想法是重用操作结果,执行繁重的操作时,我们会将结果保存在缓存容器中,下次我们需要该结果时,我们将从缓存容器中取出它,而不是再次执行繁重的 ...

  5. centos挂载本地镜像作为yum源

    1.安装Centos后默认的Yum源如下 ll /etc/yum.repos.d/   [root@localhost ~]# ll /etc/yum.repos.d/ total 32 -rw-r- ...

  6. selenium之文件上传

    文件上传是所有UI自动化测试都要面对的一个头疼问题,今天博主在这里给大家分享下自己处理文件上传的经验,希望能够帮助到广大被文件上传坑住的seleniumer. 首先,我们要区分出上传按钮的种类,大体上 ...

  7. Python 双向队列Deque、单向队列Queue 模块使用详解

    Python 双向队列Deque 模块使用详解 创建双向队列Deque序列 双向队列Deque提供了类似list的操作方法: #!/usr/bin/python3 import collections ...

  8. 谢孟军:The State of Go | ECUG Con 精粹系列

    本月 17 日,Go 1.8 版本火热发布.相较于以往的版本,Go 1.8 具体有哪些新的特性呢?想必这是不少 Gopher 们热切关注和讨论的问题.作为著名的Golang 布道者,Gopher Ch ...

  9. gitlab上fork的项目如何获取源更新

    1.添加上游项目地址 git remote add upstream URL 2.查看远程仓库信息 可以看到上游项目地址已经添加进来了 git remote -v 3.获取上游项目更新 获取到的更新会 ...

  10. Lca 之倍增算法

    引入: 比如说要找树上任意两个点的路上的最大值.如果是一般的做法 会 接近o(n)的搜,从一个点搜到另一个点,但是如果询问多了复杂度就很高了. 然后我们会预处理.预处理是o(n²)的,询问是o(1)的 ...